## ros-noetic-cob-base-controller-utils 0.8.21

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0.2)
project(cob_base_controller_utils)

find_package(catkin REQUIRED COMPONENTS controller_manager_msgs diagnostic_msgs geometry_msgs message_generation nav_msgs roscpp std_msgs std_srvs tf tf2 urdf)

find_package(Boost REQUIRED COMPONENTS thread)

add_message_files(
  DIRECTORY msg
  FILES
  WheelCommands.msg
)

generate_messages(DEPENDENCIES std_msgs)

catkin_package(
  CATKIN_DEPENDS controller_manager_msgs diagnostic_msgs geometry_msgs message_runtime nav_msgs roscpp std_msgs std_srvs tf tf2 urdf
  DEPENDS Boost
  INCLUDE_DIRS include
)

include_directories(include ${catkin_INCLUDE_DIRS} ${Boost_INCLUDE_DIRS})

add_executable(cob_halt_detector src/halt_detector.cpp)
add_dependencies(cob_halt_detector ${${PROJECT_NAME}_EXPORTED_TARGETS} ${catkin_EXPORTED_TARGETS})
target_link_libraries(cob_halt_detector ${catkin_LIBRARIES} ${Boost_LIBRARIES})

add_executable(cob_spin_detector src/spin_detector.cpp)
add_dependencies(cob_spin_detector ${${PROJECT_NAME}_EXPORTED_TARGETS} ${catkin_EXPORTED_TARGETS})
target_link_libraries(cob_spin_detector ${catkin_LIBRARIES} ${Boost_LIBRARIES})

add_executable(cob_stop_detector src/stop_detector.cpp)
add_dependencies(cob_stop_detector ${${PROJECT_NAME}_EXPORTED_TARGETS} ${catkin_EXPORTED_TARGETS})
target_link_libraries(cob_stop_detector ${catkin_LIBRARIES} ${Boost_LIBRARIES})

add_executable(cob_stuck_detector src/stuck_detector.cpp)
add_dependencies(cob_stuck_detector ${${PROJECT_NAME}_EXPORTED_TARGETS} ${catkin_EXPORTED_TARGETS})
target_link_libraries(cob_stuck_detector ${catkin_LIBRARIES} ${Boost_LIBRARIES})

### INSTALL ###
install(TARGETS cob_halt_detector cob_spin_detector cob_stop_detector cob_stuck_detector
  ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
)

install(DIRECTORY include/${PROJECT_NAME}/
 DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION}
)

catkin_install_python(PROGRAMS scripts/test_publisher_twist_sine.py scripts/test_publisher_twist_step.py
  DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
)

install(DIRECTORY launch
  DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}
)

=== debian/changelog ===
ros-noetic-cob-base-controller-utils (0.8.21-1buster) buster; urgency=high

  * Merge pull request #272 <https://github.com/ipa320/cob_control/issues/272> from Deleh/feature/diagnostic_recovery
    [WIP] Add recover from diagnostic errors
  * remove yaml. yaml should be placed in X_hardware_config
  * enhance recover from diagnostics
  * set stuck threshold log level to debug
  * also check rotation joints
  * use config file for halt detector
  * add recover from diagnostic errors
  * Contributors: Denis Lehmann, Florian Weisshardt, floweisshardt

 -- Felix Messmer <felixmessmer@gmail.com>  Tue, 03 Jan 2023 23:00:00 -0000

ros-noetic-cob-base-controller-utils (0.8.20-1buster) buster; urgency=high

  * Merge pull request #271 <https://github.com/ipa320/cob_control/issues/271> from Deleh/feature/halt_detector
    Add halt_detector
  * track stuck thresholds per wheel
  * add install tag for cob_halt_detector
  * add warning if wheel exceeds stuck threshold
  * add halt_detector
  * add recovering check
  * use ROS_INFO_STREAM
  * simplify stop detector
  * Contributors: Denis Lehmann, Felix Messmer

 -- Felix Messmer <felixmessmer@gmail.com>  Wed, 16 Nov 2022 23:00:00 -0000

ros-noetic-cob-base-controller-utils (0.8.19-1buster) buster; urgency=high

  * Merge pull request #269 <https://github.com/ipa320/cob_control/issues/269> from fmessmer/fix/switch_recover
    start controllers after recover
  * do not switch/restart odometry_controller
  * fixup controller_spawn
  * start controllers after recover
  * Merge pull request #268 <https://github.com/ipa320/cob_control/issues/268> from fmessmer/feature/stop_detector
    feature stop detector
  * only subscribe once everything is set up
  * wait for required services
  * add missing launch files
  * add stop_detector
  * Contributors: Felix Messmer, fmessmer

 -- Felix Messmer <felixmessmer@gmail.com>  Thu, 28 Jul 2022 22:00:00 -0000

ros-noetic-cob-base-controller-utils (0.8.18-1buster) buster; urgency=high



 -- Felix Messmer <felixmessmer@gmail.com>  Tue, 11 Jan 2022 23:00:00 -0000

ros-noetic-cob-base-controller-utils (0.8.17-1buster) buster; urgency=high



 -- Felix Messmer <felixmessmer@gmail.com>  Wed, 22 Dec 2021 23:00:00 -0000

ros-noetic-cob-base-controller-utils (0.8.16-1buster) buster; urgency=high



 -- Felix Messmer <felixmessmer@gmail.com>  Mon, 18 Oct 2021 22:00:00 -0000

ros-noetic-cob-base-controller-utils (0.8.15-1buster) buster; urgency=high



 -- Felix Messmer <felixmessmer@gmail.com>  Sun, 16 May 2021 22:00:00 -0000

ros-noetic-cob-base-controller-utils (0.8.14-1buster) buster; urgency=high



 -- Felix Messmer <felixmessmer@gmail.com>  Sun, 09 May 2021 22:00:00 -0000

ros-noetic-cob-base-controller-utils (0.8.13-1buster) buster; urgency=high

  * Merge pull request #247 <https://github.com/ipa320/cob_control/issues/247> from fmessmer/fix_catkin_lint_melodic
    [melodic] fix catkin_lint
  * fix catkin_lint
  * Contributors: Felix Messmer, fmessmer

 -- Felix Messmer <felixmessmer@gmail.com>  Mon, 05 Apr 2021 22:00:00 -0000

ros-noetic-cob-base-controller-utils (0.8.12-1buster) buster; urgency=high

  * Merge pull request #243 <https://github.com/ipa320/cob_control/issues/243> from fmessmer/test_noetic
    test noetic
  * Bump CMake version to avoid CMP0048 warning
  * Contributors: Felix Messmer, fmessmer

 -- Felix Messmer <felixmessmer@gmail.com>  Tue, 20 Oct 2020 22:00:00 -0000

ros-noetic-cob-base-controller-utils (0.8.11-1buster) buster; urgency=high



 -- Felix Messmer <felixmessmer@gmail.com>  Fri, 20 Mar 2020 23:00:00 -0000

ros-noetic-cob-base-controller-utils (0.8.10-1buster) buster; urgency=high

  * Merge pull request #226 <https://github.com/ipa320/cob_control/issues/226> from fmessmer/ci_updates_melodic
    [travis] ci updates - melodic
  * catkin_lint fixes
  * Contributors: Felix Messmer, fmessmer

 -- Felix Messmer <felixmessmer@gmail.com>  Tue, 17 Mar 2020 23:00:00 -0000

ros-noetic-cob-base-controller-utils (0.8.1-1buster) buster; urgency=high



 -- Felix Messmer <felixmessmer@gmail.com>  Wed, 06 Nov 2019 23:00:00 -0000

ros-noetic-cob-base-controller-utils (0.8.0-1buster) buster; urgency=high



 -- Felix Messmer <felixmessmer@gmail.com>  Thu, 08 Aug 2019 22:00:00 -0000

ros-noetic-cob-base-controller-utils (0.7.8-1buster) buster; urgency=high



 -- Felix Messmer <felixmessmer@gmail.com>  Thu, 08 Aug 2019 22:00:00 -0000

ros-noetic-cob-base-controller-utils (0.7.7-1buster) buster; urgency=high



 -- Felix Messmer <felixmessmer@gmail.com>  Mon, 05 Aug 2019 22:00:00 -0000

ros-noetic-cob-base-controller-utils (0.7.6-1buster) buster; urgency=high



 -- Felix Messmer <felixmessmer@gmail.com>  Thu, 06 Jun 2019 22:00:00 -0000

ros-noetic-cob-base-controller-utils (0.7.5-1buster) buster; urgency=high



 -- Felix Messmer <felixmessmer@gmail.com>  Sun, 19 May 2019 22:00:00 -0000

ros-noetic-cob-base-controller-utils (0.7.4-1buster) buster; urgency=high

  * Merge pull request #200 <https://github.com/ipa320/cob_control/issues/200> from iirob/stuck_detector_shutdown
    Added shutdown in stuck detector
  * Added shutdown in stuck detector
  * Contributors: Felix Messmer, andreeatulbure

 -- Felix Messmer <felixmessmer@gmail.com>  Thu, 04 Apr 2019 22:00:00 -0000

ros-noetic-cob-base-controller-utils (0.7.3-1buster) buster; urgency=high

  * Merge pull request #199 <https://github.com/ipa320/cob_control/issues/199> from fmessmer/spin_detector
    Spin detector
  * Revert "tmp: add spin_detector to launch"
    This reverts commit d08388aad4e0910f933f8439faff2ce97ba3c1a4.
  * tmp: add spin_detector to launch
  * allow shutdown vs. halt
  * add spin_detector
  * Merge pull request #196 <https://github.com/ipa320/cob_control/issues/196> from fmessmer/split_parseWheelTransform
    controller specific parseWheelTransform
  * split parseWheelTransform
  * Merge pull request #192 <https://github.com/ipa320/cob_control/issues/192> from fmessmer/fix/parseWheelTransform
    fix/parse wheel transform


=== debian/control ===
Source: ros-noetic-cob-base-controller-utils
Section: misc
Priority: optional
Maintainer: Felix Messmer <felixmessmer@gmail.com>
Build-Depends: debhelper (>= 9.0.0), ros-noetic-catkin, ros-noetic-controller-manager-msgs, ros-noetic-diagnostic-msgs, ros-noetic-geometry-msgs, ros-noetic-message-generation, ros-noetic-nav-msgs, ros-noetic-roscpp, ros-noetic-std-msgs, ros-noetic-std-srvs, ros-noetic-tf, ros-noetic-tf2, ros-noetic-urdf
Homepage: 
Standards-Version: 3.9.2

Package: ros-noetic-cob-base-controller-utils
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-noetic-controller-manager-msgs, ros-noetic-diagnostic-msgs, ros-noetic-geometry-msgs, ros-noetic-message-runtime, ros-noetic-nav-msgs, ros-noetic-roscpp, ros-noetic-rospy, ros-noetic-std-msgs, ros-noetic-std-srvs, ros-noetic-tf, ros-noetic-tf2, ros-noetic-urdf
Description: The cob_base_controller_utils package contains common utils for various base_controllers.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/noetic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF -DCATKIN_ENABLE_TESTING=OFF
endif

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/noetic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/noetic" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-noetic-cob-base-controller-utils//opt/ros/noetic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_install

## ros-noetic-cob-base-controller-utils 0.8.22

=== debian/changelog ===
ros-noetic-cob-base-controller-utils (0.8.22-1focal) focal; urgency=high

  * Merge pull request #273 <https://github.com/ipa320/cob_control/issues/273> from Deleh/fix/recover_diagnostics_when_stopped
    Recover on Diagnostics When Stopped
  * recover on diagnostics when stopped
  * Contributors: Denis Lehmann, Felix Messmer

 -- Felix Messmer <felixmessmer@gmail.com>  Fri, 28 Apr 2023 22:00:00 -0000

ros-noetic-cob-base-controller-utils (0.8.21-1focal) focal; urgency=high

  * Merge pull request #272 <https://github.com/ipa320/cob_control/issues/272> from Deleh/feature/diagnostic_recovery
    [WIP] Add recover from diagnostic errors
  * remove yaml. yaml should be placed in X_hardware_config
  * enhance recover from diagnostics
  * set stuck threshold log level to debug
  * also check rotation joints
  * use config file for halt detector
  * add recover from diagnostic errors
  * Contributors: Denis Lehmann, Florian Weisshardt, floweisshardt

 -- Felix Messmer <felixmessmer@gmail.com>  Tue, 03 Jan 2023 23:00:00 -0000

ros-noetic-cob-base-controller-utils (0.8.20-1focal) focal; urgency=high

  * Merge pull request #271 <https://github.com/ipa320/cob_control/issues/271> from Deleh/feature/halt_detector
    Add halt_detector
  * track stuck thresholds per wheel
  * add install tag for cob_halt_detector
  * add warning if wheel exceeds stuck threshold
  * add halt_detector
  * add recovering check
  * use ROS_INFO_STREAM
  * simplify stop detector
  * Contributors: Denis Lehmann, Felix Messmer

 -- Felix Messmer <felixmessmer@gmail.com>  Wed, 16 Nov 2022 23:00:00 -0000

ros-noetic-cob-base-controller-utils (0.8.19-1focal) focal; urgency=high

  * Merge pull request #269 <https://github.com/ipa320/cob_control/issues/269> from fmessmer/fix/switch_recover
    start controllers after recover
  * do not switch/restart odometry_controller
  * fixup controller_spawn
  * start controllers after recover
  * Merge pull request #268 <https://github.com/ipa320/cob_control/issues/268> from fmessmer/feature/stop_detector
    feature stop detector
  * only subscribe once everything is set up
  * wait for required services
  * add missing launch files
  * add stop_detector
  * Contributors: Felix Messmer, fmessmer

 -- Felix Messmer <felixmessmer@gmail.com>  Thu, 28 Jul 2022 22:00:00 -0000

ros-noetic-cob-base-controller-utils (0.8.18-1focal) focal; urgency=high



 -- Felix Messmer <felixmessmer@gmail.com>  Tue, 11 Jan 2022 23:00:00 -0000

ros-noetic-cob-base-controller-utils (0.8.17-1focal) focal; urgency=high



 -- Felix Messmer <felixmessmer@gmail.com>  Wed, 22 Dec 2021 23:00:00 -0000

ros-noetic-cob-base-controller-utils (0.8.16-1focal) focal; urgency=high



 -- Felix Messmer <felixmessmer@gmail.com>  Mon, 18 Oct 2021 22:00:00 -0000

ros-noetic-cob-base-controller-utils (0.8.15-1focal) focal; urgency=high



 -- Felix Messmer <felixmessmer@gmail.com>  Sun, 16 May 2021 22:00:00 -0000

ros-noetic-cob-base-controller-utils (0.8.14-1focal) focal; urgency=high



 -- Felix Messmer <felixmessmer@gmail.com>  Sun, 09 May 2021 22:00:00 -0000

ros-noetic-cob-base-controller-utils (0.8.13-1focal) focal; urgency=high

  * Merge pull request #247 <https://github.com/ipa320/cob_control/issues/247> from fmessmer/fix_catkin_lint_melodic
    [melodic] fix catkin_lint
  * fix catkin_lint
  * Contributors: Felix Messmer, fmessmer

 -- Felix Messmer <felixmessmer@gmail.com>  Mon, 05 Apr 2021 22:00:00 -0000

ros-noetic-cob-base-controller-utils (0.8.12-1focal) focal; urgency=high

  * Merge pull request #243 <https://github.com/ipa320/cob_control/issues/243> from fmessmer/test_noetic
    test noetic
  * Bump CMake version to avoid CMP0048 warning
  * Contributors: Felix Messmer, fmessmer

 -- Felix Messmer <felixmessmer@gmail.com>  Tue, 20 Oct 2020 22:00:00 -0000

ros-noetic-cob-base-controller-utils (0.8.11-1focal) focal; urgency=high



 -- Felix Messmer <felixmessmer@gmail.com>  Fri, 20 Mar 2020 23:00:00 -0000

ros-noetic-cob-base-controller-utils (0.8.10-1focal) focal; urgency=high

  * Merge pull request #226 <https://github.com/ipa320/cob_control/issues/226> from fmessmer/ci_updates_melodic
    [travis] ci updates - melodic
  * catkin_lint fixes
  * Contributors: Felix Messmer, fmessmer

 -- Felix Messmer <felixmessmer@gmail.com>  Tue, 17 Mar 2020 23:00:00 -0000

ros-noetic-cob-base-controller-utils (0.8.1-1focal) focal; urgency=high



 -- Felix Messmer <felixmessmer@gmail.com>  Wed, 06 Nov 2019 23:00:00 -0000

ros-noetic-cob-base-controller-utils (0.8.0-1focal) focal; urgency=high



 -- Felix Messmer <felixmessmer@gmail.com>  Thu, 08 Aug 2019 22:00:00 -0000

ros-noetic-cob-base-controller-utils (0.7.8-1focal) focal; urgency=high



 -- Felix Messmer <felixmessmer@gmail.com>  Thu, 08 Aug 2019 22:00:00 -0000

ros-noetic-cob-base-controller-utils (0.7.7-1focal) focal; urgency=high



 -- Felix Messmer <felixmessmer@gmail.com>  Mon, 05 Aug 2019 22:00:00 -0000

ros-noetic-cob-base-controller-utils (0.7.6-1focal) focal; urgency=high



 -- Felix Messmer <felixmessmer@gmail.com>  Thu, 06 Jun 2019 22:00:00 -0000

ros-noetic-cob-base-controller-utils (0.7.5-1focal) focal; urgency=high



 -- Felix Messmer <felixmessmer@gmail.com>  Sun, 19 May 2019 22:00:00 -0000

ros-noetic-cob-base-controller-utils (0.7.4-1focal) focal; urgency=high

  * Merge pull request #200 <https://github.com/ipa320/cob_control/issues/200> from iirob/stuck_detector_shutdown
    Added shutdown in stuck detector
  * Added shutdown in stuck detector
  * Contributors: Felix Messmer, andreeatulbure

 -- Felix Messmer <felixmessmer@gmail.com>  Thu, 04 Apr 2019 22:00:00 -0000

ros-noetic-cob-base-controller-utils (0.7.3-1focal) focal; urgency=high

  * Merge pull request #199 <https://github.com/ipa320/cob_control/issues/199> from fmessmer/spin_detector
    Spin detector
  * Revert "tmp: add spin_detector to launch"
    This reverts commit d08388aad4e0910f933f8439faff2ce97ba3c1a4.
  * tmp: add spin_detector to launch
  * allow shutdown vs. halt
